package com.bagesoft.test.designpattern.adapter;

import java.util.Enumeration;
import java.util.Iterator;

/**
 * convert from Iterator to Enumeration
 * 
 * @author bage
 * 
 * @param <T>
 */
public class Iterator2EnumerationAdapter<T> implements Enumeration<T> {
	private Iterator<T> iter;

	public Iterator2EnumerationAdapter(Iterator<T> iter) {
		this.iter = iter;
	}

	public boolean hasMoreElements() {
		return iter.hasNext();
	}

	public T nextElement() {
		return iter.next();
	}

}
