package com.bagesoft.test.designpattern.chain;

public abstract class Expert {
	private Expert next;
	protected String name;

	protected abstract boolean solve(Problem p);

	/**
	 * recursive method
	 * 
	 * @param p
	 */
	public final void support(Problem p) {
		if (solve(p)) {
			System.out.println(name + ": " + p.getName() + " 해결.");
		} else {
			if (next != null) {
				next.support(p);
			} else {
				System.out.println(p.getName() + " 해결 불가!");
			}
		}
	}

	public Expert setNext(Expert next) {
		this.next = next;
		return next;
	}
}