package com.bagesoft.test.designpattern.command2;

import java.util.ArrayList;
import java.util.List;

public class CommandStack {
	private int current = -1;
	private List<ReversibleCommand> commands = new ArrayList<ReversibleCommand>();

	public void execute(ReversibleCommand c) {
		// System.out.println("current: " + current);
		for (int i = commands.size() - 1; i > current; i--) {
			commands.remove(i);
		}

		commands.add(c);
		redo();
	}

	public void redo() {
		if (current + 1 < commands.size()) {
			commands.get(++current).redo();
		}
	}

	public void undo() {
		if (current - 1 >= 0) {
			commands.get(current--).undo();
		}
	}
}