package com.bagesoft.test.designpattern.composite;

import java.util.ArrayList;
import java.util.List;

public abstract class Component {
	private String name;
	protected List<Component> children = new ArrayList<Component>();

	public abstract void add(Component c);

	public Component(String name) {
		this.name = name;
	}

	private String toString(int depth) {
		StringBuffer sb = new StringBuffer();
		for (int i = 0; i < depth; i++) {
			sb.append("  ");
		}
	
		if (this instanceof Composite) {
			sb.append("+" + getName() + "\n");
			for (Component comp : children) {
				sb.append(comp.toString(depth + 1));
			}
		} else {
			sb.append("-" + getName() + "\n");
		}
		return sb.toString();
	}

	public String getName() {
		return name;
	}

	public List<Component> getChildren() {
		return children;
	}

	public String toString() {
		return toString(0);
	}
}