package com.bagesoft.test.designpattern.facade;

public class Home {
	private Audio audio;
	private Light light;
	private TV tv;

	public Home(Audio audio, Light light, TV tv) {
		this.audio = audio;
		this.light = light;
		this.tv = tv;
	}

	public void watchTV() {
		System.out.println("== TV보기.");
		light.setLightness(2);
		tv.turnOn();
	}

	public void listeningMusic() {
		System.out.println("== 음악듣기.");
		light.setLightness(1);
		audio.play();
	}

	public void goOut() {
		System.out.println("== 외출하기.");
		if (tv.isTurnedOn()) {
			tv.turnOff();
		}
		if (audio.isPlaying()) {
			audio.stop();
		}
		light.setLightness(0);
	}
}
