package com.bagesoft.test.designpattern.iterator;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * e.g. java.util.List <BR>
 * e.g. java.util.Set <BR>
 * 
 * @author bage
 * 
 * @param <T>
 */
public class PersonIterator<T> implements Iterable<T> {
	private List<T> list = new ArrayList<T>();

	public void add(T value) {
		list.add(value);
	}

	public Iterator<T> iterator() {
		return new Iterator<T>() {
			int index = 0;

			public boolean hasNext() {
				return index < list.size();
			}

			public T next() {
				return list.get(index++);
			}

			public void remove() {
				list.remove(index);
			}
		};
	}
}
