package com.bagesoft.test.designpattern.mediator;

public class Airplane extends Thread {
	private ControlTower tower = null;
	private final int no;

	public Airplane(int no) {
		this.no = no;
	}

	public void setMediator(ControlTower tower) {
		this.tower = tower;
	}

	public int getNo() {
		return no;
	}

	@Override
	public void run() {
		try {
			while (!tower.getPermission()) {
				System.out.println("\t" + no + "번 째 비행기 대기 중.");
				Thread.sleep(10L);
			}
			tower.land(this);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}
}