package com.bagesoft.test.designpattern.mediator;

public class ControlTower {
	private volatile boolean inUse;

	/**
	 * synchronized keyword.
	 * 
	 * @return
	 */
	public synchronized boolean getPermission() {
		if (inUse) {
			return false;
		} else {
			inUse = true;
			return true;
		}
	}

	private synchronized void releasePermission() {
		inUse = false;
	}

	public void land(Airplane airplane) throws InterruptedException {
		int seq = airplane.getNo();
		System.out.println(seq + "번 비행기 착륙 시작");
		Thread.sleep(50L);
		System.out.println(seq + "번 비행기 착륙 끝");

		releasePermission();
	}
}