package com.bagesoft.test.designpattern.mediator2;

public class Airplane2 extends Thread {
	private ControlTower2 tower = null;
	private final int no;
	private boolean done = false;

	public Airplane2(int no) {
		this.no = no;
	}

	public void setMediator(ControlTower2 tower) {
		this.tower = tower;
	}

	public int getNo() {
		return no;
	}

	public void callback() throws InterruptedException {
		tower.land(this);
		done = true;
	}

	@Override
	public void run() {
		tower.requestPermission(this);
		while (true) {
			if (done) {
				break;
			}

			try {
				Thread.sleep(10L);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
	}
}
