package com.bagesoft.test.designpattern.mediator2;

import java.util.ArrayList;
import java.util.List;

public class ControlTower2 extends Thread {
	private volatile boolean inUse = false;
	List<Airplane2> list = new ArrayList<Airplane2>();

	public boolean requestPermission(Airplane2 airplane) {
		list.add(airplane);
		return true;
	}

	@Override
	public void run() {
		while (true) {
			if (!inUse && list.size() > 0) {
				Airplane2 airplane = list.get(list.size() - 1);
				try {
					airplane.callback();
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
				list.remove(airplane);
			}

			try {
				Thread.sleep(10L);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}

			if (list.size() == 0) {
				break;
			}
		}
	}

	synchronized public void land(Airplane2 airplane)
			throws InterruptedException {
		inUse = true;

		System.out.println(airplane.getNo() + "번 비행기 착륙 시작");
		Thread.sleep(50L);
		System.out.println(airplane.getNo() + "번 비행기 착륙 끝");

		inUse = false;
	}
}
