package com.bagesoft.test.designpattern.state;

public class StateContext {
	private State currentState;

	public StateContext() {
		currentState = State.getInitState();
	}

	public void processEvent(Action action) {
		State next = currentState.act(action);
		System.out.println(action);

		if (next != null) {
			currentState.onExit();
			System.out.println("\t" + currentState + "->" + next);
			currentState = next;
			currentState.onEntry();
			if (State.isFinalState(currentState)) {
				System.out.println("\t최종상태");
			}
		} else {
			System.out.println("\t" + currentState + "에서는 의미 없는 짓.");
		}
	}
}