package com.bagesoft.test.designpattern.state2;

public class StateContext2 {
	private State2 currentState;

	public StateContext2() {
		currentState = State2.getInitState();
	}

	public void processEvent(Action2 action) {
		State2 next = currentState.act(action);
		System.out.println(action);

		if (next != null) {
			currentState.onExit();
			System.out.println("\t" + currentState.getDesc() + "->"
					+ next.getDesc());
			currentState = next;
			currentState.onEntry();
			if (State2.isFinalState(currentState)) {
				System.out.println("\t최종상태");
			}
		} else {
			System.out.println("\t" + currentState.getDesc() + "에서는 의미 없는 짓.");
		}
	}
}